Extract Inductive unit => "unit" [ "()" ].
Extract Inductive bool => "bool" [ "true" "false" ].
Extract Inductive sumbool => "bool" [ "true" "false" ].

Require Constants.

Extract Constant Constants.t => "string".
Extract Constant Constants.eq_dec => "Rconstants.eq_dec".
Extract Constant Constants.FAIL => "Rconstants.coq_FAIL".
Extract Constant Constants.CALL => "Rconstants.coq_CALL".
Extract Constant Constants.RETURN => "Rconstants.coq_RETURN".
Extract Constant Constants.NEW_NONCE => "Rconstants.coq_NEW_NONCE".
Extract Constant Constants.NEW_SYMKEY => "Rconstants.coq_NEW_SYMKEY".
Extract Constant Constants.NEW_PUBKEY => "Rconstants.coq_NEW_PUBKEY".
Extract Constant Constants.ACCEPT => "Rconstants.coq_ACCEPT".
Extract Constant Constants.CONNECT => "Rconstants.coq_CONNECT".
Extract Constant Constants.BIND => "Rconstants.coq_BIND".
Extract Constant Constants.ASSERT => "Rconstants.coq_ASSERT".
Extract Constant Constants.MSG => "Rconstants.coq_MSG".
Extract Constant Constants.MATCH => "Rconstants.coq_MATCH".
Extract Constant Constants.BACKUP => "Rconstants.coq_BACKUP".
Extract Constant Constants.SHARE => "Rconstants.coq_SHARE".
Extract Constant Constants.from_nat => "Rconstants.from_nat".

Extraction Library Constants.

Require DOrderedType.
Extract Constant DOrderedType.strt => "string".
Extraction Library DOrderedType.

Require IdSet.

(*Extract Constant IdSet.IOTt => "string".*)
Extract Constant IdSet.IOTcompare => "IOT.compare".
Extract Constant IdSet.d1 => "IOT.d1".
Extract Constant IdSet.d2 => "IOT.d2".
Extract Constant IdSet.new_id => "IOT.new_id".
Extract Constant IdSet.role_chanid => "IOT.role_chanid".
Extract Constant IdSet.nonce_id => "IOT.nonce_id".

Extraction Library IdSet.

Require WPPLi.
Recursive Extraction Library WPPLi.
Require CPPLlb.
Recursive Extraction Library CPPLlb.
Require CPPLc.
Recursive Extraction Library CPPLc.
Require CPPLss.
Recursive Extraction Library CPPLss.

Require WPPLo.
Extraction Library WPPLo.