(*pp ../../comp/cpplc -d *)

(*  
 // lowe modified ksl 
  
 a, b, s :              principal            
 na, nb, nc, ma, mb :   number               
 kas, kbs, kab, kbb :   key                  
 tb :                   generalizedtimestamp 
  
  
 1.   a -> b  :   na, a                                            
 2.   b -> s  :   na, a, nb, b                                     
 3.   s -> b  :   {nb, a, kab}kbs, {na, b, kab}kas                  
 4.   b -> a  :   {na, b, kab}kas, {tb, a, kab}kbb, nc, {b, na}kab 
 5.   a -> b  :   {nc}kab                                          
                                                                   
 6.   a -> b  :   ma, {tb, a, kab}kbb                              
 7.   b -> a  :   mb, {ma, b}kab                                   
 8.   a -> b  :   {a, mb}kab                                       
   
 // security protocols open repository 
 // http://www.lsv.ens-cachan.fr/spore 
*)
(spec
 ([a (a:name b:name s:name kas:symkey) (kab:symkey)]
  [b (b:name s:name kbs:symkey) (kab:symkey)]
  [s (a:name b:name s:name kas:symkey kbs:symkey) (kab:symkey)])

 [a -> b : na:nonce, a]
 [b -> s : na, a, nb:nonce, b]
 [s -> b : {|nb, a, kab:symkey|} kbs, {|na, b, kab|} kas]
 [b -> a : {|na, b, kab|} kas, {|tb:nonce, a, kab|} kbb:symkey,
           nc:nonce, {|b, na|} kab]
 [a -> b : {|nc|} kab]
 (*
 [a -> b : ma:nonce, {|tb, a, kab|} kbb]
 [b -> a : mb:nonce, {|ma|} kab]
 [a -> b : {|mb|} kab]
 *)
 .)
