Require Import OrderedType.

Parameter strt : Set.

Module Type DUsualOrderedType.
 Parameter t : Set.
 Definition eq := @eq t.
	
 Parameter str : strt -> t.
 Parameter rts : t -> strt.
 Parameter lt : t -> t -> Prop.
 Definition eq_refl := @refl_equal t.
 Definition eq_sym := @sym_eq t.
 Definition eq_trans := @trans_eq t.
 Axiom lt_trans : forall x y z : t, lt x y -> lt y z -> lt x z.
 Axiom lt_not_eq : forall x y : t, lt x y -> ~ eq x y.
 Parameter compare : forall x y : t, Compare lt eq x y.

 Parameter new_id : unit -> t .
 Parameter d1 : t.
	
 Parameter d2 : t.
 Parameter role_chanid : t -> t.
End DUsualOrderedType.