open Datatypes

let eq_dec s1 s2 = s1 = s2

let coq_FAIL = "fail"
let coq_CALL = "call"
let coq_RETURN = "ret"
let coq_NEW_NONCE = "new_nonce"
let coq_NEW_SYMKEY = "new_symkey"
let coq_NEW_PUBKEY = "new_pubkey"
let coq_ACCEPT = "accept"
let coq_CONNECT = "connect"
let coq_BIND = "bind"
let coq_ASSERT = "assert"
let coq_MSG = "msg"
let coq_MATCH = "match"
let coq_BACKUP = "backup"
let coq_SHARE = "share"

let rec nat2intr n i =
  match n with
    | O -> i
    | S n -> nat2intr n (i+1)

let nat2int n = nat2intr n 0

let rec from_nat n =
  Printf.sprintf "%n" (nat2int n)
